<?php
/***************************************************************************
 *                               links.php
 *                            -------------------
 *   begin                :  Sep, 2003
 *   author               : Niels Chr. Denmark <ncr@db9.dk> (http://mods.db9.dk)
 *
 * version 0.9.0
 *
 * History:
 *   0.9.0. - initial BETA
 *
 * a fully phpBB2 integrated links page
 *
 ***************************************************************************/
/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_LINKS);
init_userprefs($userdata);
//
// End session management
//

$template->set_filenames(array( 
	'body' => 'links_body.tpl'));

	$template->assign_vars(array( 
	'L_LINK_TITLE' => $lang['Links_title']));

$sql_level = ($userdata['user_id']==ANONYMOUS) ? ANONYMOUS : (($userdata['user_level']==ADMIN) ? MOD : (($userdata['user_level']==MOD) ? ADMIN : $userdata['user_level'])); 
$sql = "SELECT * FROM ".LINKS_TABLE." 
		WHERE link_active
		AND (IF(link_level_type,IF(link_level_type=1,'$sql_level'<=link_level,IF(link_level_type=2,'$sql_level'>=link_level,'$sql_level'<>link_level)),link_level='$sql_level') OR link_id=0)
		ORDER BY link_cat , link_sub, link_id";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not get shoutbox information', '', __LINE__, __FILE__, $sql);
}
$links = $db->sql_fetchrowset($result);

$i=0;
if (!empty($links))
{
while (list ($id,$link) = each($links))
{
	$link_name = stripslashes($link['link_name']);
	if ($link['link_id']==0)
	{
		if ($link['link_sub']==0)
		{
			// new cat
			// only show if, link pressent in this cat
			$s=1;
			$found = FALSE;
			while ($links[$id+$s][link_cat]==$link[link_cat] && $s<sizeof($links))
			{
				$found = ($links[$id+$s++][link_id]!=0) ? TRUE : $found;
			}
			if ($found)
			{
				if ($i==0)
				{
					$i=3;
					$template->assign_block_vars('row', array());
				} else
				{
					$i--;
				}
				$template->assign_block_vars('row.cat', array(
					'CAT_NAME' => $link_name));
			}
		} else
		{
			// only show if, LINK pressent in this SUB
			$s=1;
			$found = FALSE;
			while ($links[$id+$s][link_sub]==$link[link_sub] && $s<sizeof($links))
			{
				$found = ($links[$id+$s++][link_id]!=0) ? TRUE : $found;
			}
			if ($found)
			{
				$template->assign_block_vars('row.cat.sub', array(
					'SUB_NAME' => $link_name));
			}
		}
	} else
	{
		$row_color = $theme['td_color1'];
		$row_class = $theme['td_class1'];
		$template->assign_block_vars('row.cat.sub.link', array(
				'LINK_NAME' => $link_name,
				'LINK_URL' => $link['link_url'],
				'ROW_COLOR' => '#' . $row_color,
				'ROW_CLASS' => $row_class));
	}
}
} else
{
	$template->assign_block_vars('row', array());
	$template->assign_block_vars('row.cat', array(
		'CAT_NAME' => $lang['No_links']));
}
// verify once more if links was showen
if (!($template->_tpldata['row.'][0]))
{
	$template->assign_block_vars('row', array());
	$template->assign_block_vars('row.cat', array('CAT_NAME' => $lang['No_links']));
}

include($phpbb_root_path . 'includes/page_header.'.$phpEx);
//
// Generate the page
//
$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);


?>
